#include <stdio.h>
#include <stdlib.h>
#include "imageUtilities.h"

int main(int argc, char** argv)
{
	if(argc == 1) 
	{
		printf("Error! No file name\n");
		exit(1);
	}

	Pgm *imgIn = readPGM(argv[1]);
	
	if(imgIn == NULL)
		exit(2);

	Pgm* imgOut = newPGM(imgIn->width, imgIn->height, imgIn->max_val);
		
	// copy the image
	copyPGM(imgIn,imgOut);
	writePGM(imgOut,"copy.pgm");
	// flip the image
	resetPGM(imgOut);
	hflipPGM(imgIn,imgOut);
	writePGM(imgOut,"flip.pgm");
	// invert the image
	resetPGM(imgOut);
	invertPGM(imgIn,imgOut);
	writePGM(imgOut,"invert.pgm");
	
	// calculate histogram and write it in a file 
	int i;
	int* histogram = histogramPGM(imgIn);
	FILE* hist = fopen("histogram.dat", "w");
	
	for(i=0; i<256; i++)
	{
		printf("HISTOGRAM[%d] = %d\n", i, histogram[i]);
		fprintf(hist, "%d %d\n", i, histogram[i]);
	}
	
	fclose(hist);
	free(histogram);
	freePGM(&imgIn);	
	freePGM(&imgOut);
		
	return 0;

}
